Bug 1277956 - Review Request: R-digest - Create Cryptographic Hash Digest of R Objects
Summary: Review Request: R-digest - Create Cryptographic Hash Digest of R Objects
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1277961 1277970
TreeView+ depends on / blocked
 
Reported: 2015-11-04 12:25 UTC by Tom "spot" Callaway
Modified: 2015-12-11 23:52 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-12-11 23:52:47 UTC
puntogil: fedora-review+


Attachments (Terms of Use)

Description Tom "spot" Callaway 2015-11-04 12:25:20 UTC
Spec URL: https://spot.fedorapeople.org/R-digest.spec
SRPM URL: https://spot.fedorapeople.org/R-digest-0.6.8-1.fc23.src.rpm
Description: 
Implementation of a function 'digest()' for the creation of hash digests of
arbitrary R objects (using the md5, sha-1, sha-256, crc32, xxhash and
murmurhash algorithms) permitting easy comparison of R language objects, as
well as a function 'hmac()' to create hash-based message authentication code.
The md5 algorithm by Ron Rivest is specified in RFC 1321, the sha-1 and
sha-256 algorithms are specified in FIPS-180-1 and FIPS-180-2, and the crc32
algorithm is described in
ftp://ftp.rocksoft.com/cliens/rocksoft/papers/crc_v3.txt. For md5, sha-1,
sha-256 and aes, this package uses small standalone implementations that were
provided by Christophe Devine. For crc32, code from the zlib library is used.
For sha-512, an implementation by Aaron D. Gifford is used. For xxHash, the
implementation by Yann Collet is used. For murmurhash, an implementation by
Shane Day is used. Please note that this package is not meant to be deployed
for cryptographic purposes for which more comprehensive (and widely tested)
libraries such as OpenSSL should be used.
Fedora Account System Username: spot

Comment 1 Tom "spot" Callaway 2015-11-04 12:33:50 UTC
Koji Rawhide Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11699598

Comment 2 gil cattaneo 2015-11-09 22:56:52 UTC
can you take this for me  https://bugzilla.redhat.com/show_bug.cgi?id=1258274 ?

Comment 3 gil cattaneo 2015-11-10 00:30:55 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines
- Package have the default element marked as %%doc :DESCRIPTION


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later)", "Unknown or generated", "zlib/libpng",
     "GPL (v2 or later) (with incorrect FSF address)", "BSD (3 clause)",
     "BSD (2 clause)". 28 files have unknown license. Detailed output of
     licensecheck in /home/gil/1277956-R-digest/licensecheck.txt

BSD (2 clause)
--------------
digest/digest/src/xxhash.c
digest/digest/src/xxhash.h
xxHash is available here https://github.com/Cyan4973/xxHash

BSD (3 clause)
--------------
digest/digest/src/sha2.c
digest/digest/src/sha2.h

GPL (v2 or later)
-----------------
digest/digest/R/digest.R
digest/digest/inst/include/pmurhashAPI.h
digest/digest/src/digest.c
digest/digest/src/init.c

GPL (v2 or later) (with incorrect FSF address)
----------------------------------------------
digest/digest/src/aes.c
digest/digest/src/sha256.c

Please, report to upstream https://fedoraproject.org/wiki/Common_Rpmlint_issues#incorrect-fsf-address

MIT see https://code.google.com/p/smhasher/
----------------------------------------------
digest/digest/src/pmurhash.c
digest/digest/src/pmurhash.h

zlib/libpng
-----------
digest/digest/src/crc32.c
digest/digest/src/zconf.h
digest/digest/src/zlib.h
digest/digest/src/zutil.h

Unknown or generated
--------------------
digest/digest/ChangeLog
digest/digest/DESCRIPTION
digest/digest/MD5
digest/digest/NAMESPACE
digest/digest/R/AES.R
digest/digest/R/hmac.R
digest/digest/README.md
digest/digest/cleanup
digest/digest/inst/GPL-2
digest/digest/man/AES.Rd
digest/digest/man/digest.Rd
digest/digest/man/hmac.Rd
digest/digest/src/aes.h
digest/digest/src/crc32.h
digest/digest/src/md5.c
digest/digest/src/md5.h
digest/digest/src/raes.c
digest/digest/src/sha1.c
digest/digest/src/sha1.h
digest/digest/src/sha256.h
digest/digest/tests/AESTest.R
digest/digest/tests/AESTest.Rout.save
digest/digest/tests/digestTest.R
digest/digest/tests/digestTest.Rout.save
digest/digest/tests/hmacTest.R
digest/digest/tests/hmacTest.Rout.save

Please, report to upstream and ask to add license headers in those files where is missing
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Text

Please, change license field in GPLv2 and BSD and MIT and zlib
and add Provides: bundle(foo)

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

R:
[x]: Package contains the mandatory BuildRequires.
[x]: The package has the standard %install section.
[x]: Package requires R-core.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in R
     -digest-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define packname digest
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.

R:
[x]: The %check macro is present
[x]: Latest version is packaged.
     Note: Latest upstream version is 0.6.8, packaged version is 0.6.8

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/gil/1277956-R-digest/results/R-digest-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-devel-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-debuginfo-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-debuginfo-0.6.8-1.fc24.i686.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-i386/root/ --releasever 24 install /home/gil/1277956-R-digest/results/R-digest-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-devel-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-debuginfo-0.6.8-1.fc24.i686.rpm /home/gil/1277956-R-digest/results/R-digest-debuginfo-0.6.8-1.fc24.i686.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: R-digest-0.6.8-1.fc24.i686.rpm
          R-digest-devel-0.6.8-1.fc24.i686.rpm
          R-digest-debuginfo-0.6.8-1.fc24.i686.rpm
          R-digest-0.6.8-1.fc24.src.rpm
R-digest.i686: W: spelling-error %description -l en_US sha -> aha, sh, ha
R-digest.i686: W: spelling-error %description -l en_US xxhash -> xx hash, xx-hash, hashish
R-digest.i686: W: spelling-error %description -l en_US murmurhash -> murmur hash, murmur-hash, murmurous
R-digest.i686: W: spelling-error %description -l en_US hmac -> mac, mach, h mac
R-digest.i686: W: spelling-error %description -l en_US aes -> eyes, sea, as
R-digest.i686: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
R-digest.i686: W: spelling-error %description -l en_US Gifford -> Clifford
R-digest.i686: W: spelling-error %description -l en_US xxHash -> xx Hash, xx-hash, hashish
R-digest.i686: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
R-digest-devel.i686: W: only-non-binary-in-usr-lib
R-digest-devel.i686: W: no-documentation
R-digest-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/digest/digest/src/sha256.c
R-digest-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/digest/digest/src/aes.c
R-digest.src: W: spelling-error %description -l en_US sha -> aha, sh, ha
R-digest.src: W: spelling-error %description -l en_US xxhash -> xx hash, xx-hash, hashish
R-digest.src: W: spelling-error %description -l en_US murmurhash -> murmur hash, murmur-hash, murmurous
R-digest.src: W: spelling-error %description -l en_US hmac -> mac, mach, h mac
R-digest.src: W: spelling-error %description -l en_US aes -> eyes, sea, as
R-digest.src: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
R-digest.src: W: spelling-error %description -l en_US Gifford -> Clifford
R-digest.src: W: spelling-error %description -l en_US xxHash -> xx Hash, xx-hash, hashish
R-digest.src: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
4 packages and 0 specfiles checked; 2 errors, 20 warnings.




Requires
--------
R-digest-devel (rpmlib, GLIBC filtered):
    R-digest(x86-32)

R-digest (rpmlib, GLIBC filtered):
    R-core
    libR.so
    libc.so.6
    rtld(GNU_HASH)

R-digest-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
R-digest-devel:
    R-digest-devel
    R-digest-devel(x86-32)

R-digest:
    R-digest
    R-digest(x86-32)

R-digest-debuginfo:
    R-digest-debuginfo
    R-digest-debuginfo(x86-32)



Unversioned so-files
--------------------
R-digest: /usr/lib/R/library/digest/libs/digest.so

Source checksums
----------------
ftp://cran.r-project.org/pub/R/contrib/main/digest_0.6.8.tar.gz :
  CHECKSUM(SHA256) this package     : 3062422c2ca917e52749464d63084a0d3cc061f59083f069280ec26336ce2f55
  CHECKSUM(SHA256) upstream package : 3062422c2ca917e52749464d63084a0d3cc061f59083f069280ec26336ce2f55


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/bin/fedora-review -b 1277956 --plugins R -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, R, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 4 gil cattaneo 2015-11-10 00:33:00 UTC
Issues:

[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later)", "Unknown or generated", "zlib/libpng",
     "GPL (v2 or later) (with incorrect FSF address)", "BSD (3 clause)",
     "BSD (2 clause)". 28 files have unknown license. Detailed output of
     licensecheck in /home/gil/1277956-R-digest/licensecheck.txt

BSD (2 clause)
--------------
digest/digest/src/xxhash.c
digest/digest/src/xxhash.h
xxHash is available here https://github.com/Cyan4973/xxHash

BSD (3 clause)
--------------
digest/digest/src/sha2.c
digest/digest/src/sha2.h

GPL (v2 or later)
-----------------
digest/digest/R/digest.R
digest/digest/inst/include/pmurhashAPI.h
digest/digest/src/digest.c
digest/digest/src/init.c

GPL (v2 or later) (with incorrect FSF address)
----------------------------------------------
digest/digest/src/aes.c
digest/digest/src/sha256.c

Please, report to upstream https://fedoraproject.org/wiki/Common_Rpmlint_issues#incorrect-fsf-address

MIT see https://code.google.com/p/smhasher/
----------------------------------------------
digest/digest/src/pmurhash.c
digest/digest/src/pmurhash.h

zlib/libpng
-----------
digest/digest/src/crc32.c
digest/digest/src/zconf.h
digest/digest/src/zlib.h
digest/digest/src/zutil.h

Unknown or generated
--------------------
digest/digest/ChangeLog
digest/digest/DESCRIPTION
digest/digest/MD5
digest/digest/NAMESPACE
digest/digest/R/AES.R
digest/digest/R/hmac.R
digest/digest/README.md
digest/digest/cleanup
digest/digest/inst/GPL-2
digest/digest/man/AES.Rd
digest/digest/man/digest.Rd
digest/digest/man/hmac.Rd
digest/digest/src/aes.h
digest/digest/src/crc32.h
digest/digest/src/md5.c
digest/digest/src/md5.h
digest/digest/src/raes.c
digest/digest/src/sha1.c
digest/digest/src/sha1.h
digest/digest/src/sha256.h
digest/digest/tests/AESTest.R
digest/digest/tests/AESTest.Rout.save
digest/digest/tests/digestTest.R
digest/digest/tests/digestTest.Rout.save
digest/digest/tests/hmacTest.R
digest/digest/tests/hmacTest.Rout.save

Please, report to upstream and ask to add license headers in those files where is missing
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Text

Please, change license field in GPLv2 and BSD and MIT and zlib
and add Provides: bundle(foo)

[!]: Package contains no bundled libraries without FPC exception.

[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define packname digest

Comment 5 gil cattaneo 2015-11-10 02:16:13 UTC
can you take this for me  https://bugzilla.redhat.com/show_bug.cgi?id=995435 ?

Comment 7 gil cattaneo 2015-11-10 19:54:01 UTC
should not add also
Provides:         bundled(smhasher)
Provides:         bundled(zlib)
?

Comment 8 gil cattaneo 2015-11-11 17:55:43 UTC
Remain a doubt about bundled libraries. Please, fix before import.
Approved.

Comment 9 Tom "spot" Callaway 2015-11-11 18:08:53 UTC
I didn't, because the zlib files are just the headers (no library code) and I do not believe it is all of smhasher, just part of it.

Comment 10 Gwyn Ciesla 2015-11-11 19:23:48 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/R-digest

Comment 11 Fedora Update System 2015-12-01 20:46:28 UTC
R-DBI-0.3.1-1.fc23 R-testthat-0.11.0-2.fc23 R-crayon-1.3.1-2.fc23 R-memoise-0.2.1-2.fc23 R-praise-1.0.0-2.fc23 R-digest-0.6.8-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-bc7d4f9a1c

Comment 12 Fedora Update System 2015-12-04 01:37:51 UTC
R-DBI-0.3.1-1.fc23, R-crayon-1.3.1-2.fc23, R-digest-0.6.8-2.fc23, R-memoise-0.2.1-2.fc23, R-praise-1.0.0-2.fc23, R-testthat-0.11.0-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update R-DBI R-testthat R-crayon R-memoise R-digest R-praise'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-bc7d4f9a1c

Comment 13 Fedora Update System 2015-12-11 23:52:34 UTC
R-DBI-0.3.1-1.fc23, R-crayon-1.3.1-2.fc23, R-digest-0.6.8-2.fc23, R-memoise-0.2.1-2.fc23, R-praise-1.0.0-2.fc23, R-testthat-0.11.0-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.